;Filename: TClr.s
;Part: ADuC703x.
;Created: 12/04/2006
;Author: Eckart Hartmann of Analog Devices
;This file is in beta sampling.

;This software is supplied subject our standard software license agreement.
;A non-binding summary is as follows:
;"You may use the software in your own code at your own risk.
;" ADI inc disclaims any warranty or liability of its use".
;The full standard software license agreement is available on request and
; remains the binding agreement.

#include        "..\Fla\ADuC703xi.equ"
Z_TnLD      DEFINE  0x300
Z_TnVAL     DEFINE  0x304
Z_TnCON     DEFINE  0x308
Z_TnCLRI    DEFINE  0x30c
Z_TnCAP     DEFINE  0x310

; TClr==========Clears the timer interrupt.
; C Function prototype: int TClr(int iT);
;iT:{T_T0,T_T1,T_T2,T_T3,T_T4}
; Description of Function: Sets the TCLRI, an 8bit register. When any value
;   is written to this register, the timer interrupt will be cleared.
; User interface:
;   Set iT to desired Timer, 0 to 4.
;   Call TClr(iT);
;   Returns 1 in r0
; Side effects: Corrupts r3

                RSEG CODE
                MODULE TClr
                PUBLIC TClr
                CODE32

TClr:
        mov     r3,#0xff0000            ;r3 = Z_BASE;
        orr     r3,r3,#0xff000000
        cmp     r0,#4                   ;Ensure valid timer.
        andne   r0,r0,#3
        orr     r3,r3,r0,lsl#5          ;Z_BASE |= r0<<5;
        cmp     r0,#0                   ;If T0
        addeq   r3,r3,#4                ; Z_BASE += 4.

        mov     r0,#1                   ;For return true.
        str     r0,[r3,#Z_TnCLRI]       ;write 1 into TnCLRI
        bx      lr

                 ENDMOD  TClr
                 END

